//+------------------------------------------------------------------+
//|                                          Breakeven-Line_Indi.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window


extern bool use_Comment = TRUE;
extern color longColor = Aqua;
extern color shortColor = Magenta;
extern string note3 = "Font Size";
extern int    FontSize=12;
extern string note4 = "Font Type";
extern string FontType="Vendana";
extern string note5 = "Display the price in what corner?";
extern string note6 = "Upper left=0; Upper right=1";
extern string note7 = "Lower left=2; Lower right=3";
extern int    WhatCorner=2;


int firstbuy,firstsell;
int buys,sells,prevbuys,prevsells;
double g_point,point;
double blots3,slots3;
double bprofit,sprofit;
double bswap,sswap,prevbswap,prevsswap;
double bpb, bps;
double bppp,sppp;
double tv1;
string an;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   IndicatorShortName("Breakeven-Line_Indi");
   
   int    i, k=ObjectsTotal();
   string on;
   
   for (i=0; i<k; i++) 
      {
      on=ObjectName(i);
      if (StringSubstr(on, 0)=="breakBuy")
         {
         ObjectDelete("breakBuy"); break;
         }
      if (StringSubstr(on, 0)=="breakSell")
         {
         ObjectDelete("breakSell"); break;
         }
      }
   Comment("");   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  ObjectsDeleteAll();
  Comment("");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   
//----

   double tv1=MarketInfo(Symbol(),MODE_TICKVALUE);
   
   buys=0; sells=0;
   blots3=0; slots3=0;
   bprofit=0; sprofit=0;
   bswap=0; sswap=0;
   //bpb=0; bps=0;
   
   if (Point == 0.00001) g_point = 0.0001;
   else 
   if (Point == 0.001) g_point = 0.01;
   else g_point = Point;
   
   
   
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)
            {
            buys++;
            blots3+=OrderLots();
            bprofit+=OrderProfit()+OrderCommission()+OrderSwap();
            bswap+=OrderSwap()+OrderCommission();
            if(buys==1)firstbuy=OrderTicket();
            }
         if(OrderType()==OP_SELL) sells++;
            {
            sells++;
            slots3+=OrderLots();
            sprofit+=OrderProfit()+OrderCommission()+OrderSwap();
            sswap+=OrderSwap()+OrderCommission();
            if(sells==1)firstsell=OrderTicket();
            }
        }
     }
   if(buys==0)
      {
      for (i=0; i<ObjectsTotal(); i++) 
         {
         an=ObjectName(i);
         if (StringSubstr(an, 0)=="breakBuy")ObjectDelete("breakBuy"); 
         }
      }
      
   if(sells==0)
      {
      for (i=0; i<ObjectsTotal(); i++) 
         {
         an=ObjectName(i);
         if (StringSubstr(an, 0)=="breakSell")ObjectDelete("breakSell"); 
         }
      }
      
    bppp=0;
    sppp=0;
    bppp=tv1*blots3;
    sppp=tv1*slots3;
           
//----

   //Comment ("BreakevenPoint =  ",bpb,"\npoint = ",Point,"\nbswappoint = ",bswap,"      ",calcbuy(),"      ",calcsell());
             
   
   if(buys>=2&&(bprofit<0||bswap<0)&&(buys!=prevbuys||bswap!=prevbswap)){calcbuy(); drawBuyLine();} //||ObjectFind("breakBuy")==false)
   if(sells>=2&&(sprofit<0||sswap<0)&&(sells!=prevsells||sswap!=prevsswap)){calcsell();drawSellLine();}
   
   prevbuys=buys;
   prevbswap=bswap;
   prevsells=sells;
   prevsswap=sswap;
   
    if(use_Comment)
      {
      string sb=DoubleToStr(calcbuy(),Digits);
      string ss=DoubleToStr(calcsell(),Digits);
      string bp=DoubleToStr(bppp,2); 
      string sp=DoubleToStr(sppp,2);   
      /*ObjectSetText("bpb","BreakevenLong  : "+sb+"   $ / pip = "+bp, 12, "Vendana", longColor);
      ObjectSetText("bps","BreakevenShort : "+ss+"   $ / pip = "+sp, 12, "Vendana", shortColor);
      Createtext2( "bps",10,5,corner);
      Createtext1( "bpb",10,23,corner);*/
      
      ObjectCreate("bpb", OBJ_LABEL,0, 0, 0 );
      ObjectSetText("bpb","BreakevenLong  : "+sb+"   $ / pip = "+bp, 12, "Vendana", longColor);
      ObjectSet( "bpb", OBJPROP_CORNER,WhatCorner  );
      ObjectSet( "bpb", OBJPROP_XDISTANCE,10);
      ObjectSet( "bpb", OBJPROP_YDISTANCE,23);
      ObjectSet( "bpb", OBJPROP_BACK, true );
      
      ObjectCreate("bps", OBJ_LABEL,0, 0, 0 );
      ObjectSetText("bps","BreakevenLong  : "+ss+"   $ / pip = "+sp, 12, "Vendana", longColor);
      ObjectSet( "bps", OBJPROP_CORNER,WhatCorner  );
      ObjectSet( "bps", OBJPROP_XDISTANCE,10);
      ObjectSet( "bps", OBJPROP_YDISTANCE,5);
      ObjectSet( "bps", OBJPROP_BACK, true );     
      }
   
   return(0);
  }
//+------------------------------------------------------------------+

double calcbuy()
   {
   double spread=MarketInfo(Symbol(),MODE_SPREAD)*Point;
   double tv=MarketInfo(Symbol(),MODE_TICKVALUE);
   double ml=MarketInfo(Symbol(),MODE_MINLOT);
   double bid=MarketInfo(Symbol(),MODE_BID)*Point;
   double bprice=0,bprice1=0,bprice2=0;
   double blots=0,blots1=0,blots2=0;
   double bswappoint=0;
   
   bpb=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_BUY)
            {
            if(OrderOpenPrice()>bid)
               {
               bprice1=OrderOpenPrice()+spread;
               }
            else
               bprice1=OrderOpenPrice();
            blots1=OrderLots()/ml;
            blots2+=OrderLots();
            bprice2=bprice1*blots1;
            bprice+=bprice2;
            blots+=blots1;
           
            }
         }
      }
      
   bswappoint=MathAbs(bswap/tv/blots2); 
   if(bswappoint<1)bswappoint=Point;
   else
   bswappoint=bswappoint*Point;
   
   bpb=(bprice/blots)+bswappoint; // (bprice/blots); //+     /tv/blots*Point/blots2
   
   
   //bpb=(bprofit/(blots*tv*Point))+bid;
   return(bpb);
   
   }
   
   
double calcsell()
   {
   double ask=MarketInfo(Symbol(),MODE_ASK);
   double spread=MarketInfo(Symbol(),MODE_SPREAD)*Point;
   double tv=MarketInfo(Symbol(),MODE_TICKVALUE);
   double ml=MarketInfo(Symbol(),MODE_MINLOT);
   double sprice=0,sprice1=0,sprice2=0;
   double slots=0,slots1=0,slots2=0;
   double sswappoint=0;
   
   bps=0;

   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol())
        {
         if(OrderType()==OP_SELL)
            {
            if(OrderOpenPrice()<ask)
               {
               sprice1=OrderOpenPrice()-spread;
               }
            else
            sprice1=OrderOpenPrice();
            slots1=OrderLots()/ml;
            slots2+=OrderLots();
            sprice2=sprice1*slots1;
            sprice+=sprice2;
            slots+=slots1;
           
            }
         }
      }
      
   sswappoint=MathAbs(sswap/tv/slots2); 
   if(sswappoint<1)sswappoint=Point;
   else
   sswappoint=sswappoint*Point;
   
   bps=(sprice/slots)-sswappoint; // (bprice/blots); //+     /tv/blots*Point/blots2
   
   
   //bpb=(bprofit/(blots*tv*Point))+bid;
   return(bps);
   
   
   
   
   }   
   
   
void drawBuyLine()
   {
   int    i, k=ObjectsTotal();
   string on;
   
   for (i=0; i<k; i++) 
      {
      on=ObjectName(i);
      if (StringSubstr(on, 0)=="breakBuy")
         {
         ObjectDelete("breakBuy"); break;
         }
      }
   
   
   string nmb="breakBuy";
   double p1=calcbuy(); // bpb; //
   color cl=longColor;
   int st=1;
   int wd=1;
   ObjectCreate(nmb, OBJ_HLINE, 0, 0,0);
   ObjectSet(nmb, OBJPROP_PRICE1, p1);
   ObjectSet(nmb, OBJPROP_COLOR , cl);
   ObjectSet(nmb, OBJPROP_STYLE , st);
   ObjectSet(nmb, OBJPROP_WIDTH , wd);
   }
   
   
void drawSellLine()
   {
   int    i, k=ObjectsTotal();
   string on;
   
   for (i=0; i<k; i++) 
      {
      on=ObjectName(i);
      if (StringSubstr(on, 0)=="breakSell")
         {
         ObjectDelete("breakSell"); break;
         }
      }
   
   
   string nmb="breakSell";
   double p1=calcsell(); // bpb; //
   color cl=shortColor;
   int st=1;
   int wd=1;
   ObjectCreate(nmb, OBJ_HLINE, 0, 0,0);
   ObjectSet(nmb, OBJPROP_PRICE1, p1);
   ObjectSet(nmb, OBJPROP_COLOR , cl);
   ObjectSet(nmb, OBJPROP_STYLE , st);
   ObjectSet(nmb, OBJPROP_WIDTH , wd);
   }
   
   
/*int Createtext1( string a, int x, int y , int c) {
   ObjectCreate( a, OBJ_LABEL,0, 0, 0 );
   ObjectSet( a, OBJPROP_CORNER, c );
   ObjectSet( a, OBJPROP_XDISTANCE,x);
   ObjectSet( a, OBJPROP_YDISTANCE,y);
   ObjectSet( a, OBJPROP_BACK, true );
   return(0);
   }
   
int Createtext2( string a, int x, int y , int c) {
   ObjectCreate( a, OBJ_LABEL,0, 0, 0 );
   ObjectSet( a, OBJPROP_CORNER, c );
   ObjectSet( a, OBJPROP_XDISTANCE,x);
   ObjectSet( a, OBJPROP_YDISTANCE,y);
   ObjectSet( a, OBJPROP_BACK, true );
   return(0);
   }*/